<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CardsExpirationListSearchResult StructType
 * @subpackage Structs
 */
class CardsExpirationListSearchResult extends AbstractStructBase
{
    /**
     * The Start
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Start;
    /**
     * The Limit
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Limit;
    /**
     * The Count
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Count;
    /**
     * The CardExpirationCountsList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\ArrayType\ArrayOfCardExpirationCounts
     */
    public $CardExpirationCountsList;
    /**
     * Constructor method for CardsExpirationListSearchResult
     * @uses CardsExpirationListSearchResult::setStart()
     * @uses CardsExpirationListSearchResult::setLimit()
     * @uses CardsExpirationListSearchResult::setCount()
     * @uses CardsExpirationListSearchResult::setCardExpirationCountsList()
     * @param int $start
     * @param int $limit
     * @param int $count
     * @param \eBizCharge\ArrayType\ArrayOfCardExpirationCounts $cardExpirationCountsList
     */
    public function __construct($start = null, $limit = null, $count = null, \eBizCharge\ArrayType\ArrayOfCardExpirationCounts $cardExpirationCountsList = null)
    {
        $this
            ->setStart($start)
            ->setLimit($limit)
            ->setCount($count)
            ->setCardExpirationCountsList($cardExpirationCountsList);
    }
    /**
     * Get Start value
     * @return int
     */
    public function getStart()
    {
        return $this->Start;
    }
    /**
     * Set Start value
     * @param int $start
     * @return \eBizCharge\StructType\CardsExpirationListSearchResult
     */
    public function setStart($start = null)
    {
        // validation for constraint: int
        if (!is_null($start) && !(is_int($start) || ctype_digit($start))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($start, true), gettype($start)), __LINE__);
        }
        $this->Start = $start;
        return $this;
    }
    /**
     * Get Limit value
     * @return int
     */
    public function getLimit()
    {
        return $this->Limit;
    }
    /**
     * Set Limit value
     * @param int $limit
     * @return \eBizCharge\StructType\CardsExpirationListSearchResult
     */
    public function setLimit($limit = null)
    {
        // validation for constraint: int
        if (!is_null($limit) && !(is_int($limit) || ctype_digit($limit))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($limit, true), gettype($limit)), __LINE__);
        }
        $this->Limit = $limit;
        return $this;
    }
    /**
     * Get Count value
     * @return int
     */
    public function getCount()
    {
        return $this->Count;
    }
    /**
     * Set Count value
     * @param int $count
     * @return \eBizCharge\StructType\CardsExpirationListSearchResult
     */
    public function setCount($count = null)
    {
        // validation for constraint: int
        if (!is_null($count) && !(is_int($count) || ctype_digit($count))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($count, true), gettype($count)), __LINE__);
        }
        $this->Count = $count;
        return $this;
    }
    /**
     * Get CardExpirationCountsList value
     * @return \eBizCharge\ArrayType\ArrayOfCardExpirationCounts|null
     */
    public function getCardExpirationCountsList()
    {
        return $this->CardExpirationCountsList;
    }
    /**
     * Set CardExpirationCountsList value
     * @param \eBizCharge\ArrayType\ArrayOfCardExpirationCounts $cardExpirationCountsList
     * @return \eBizCharge\StructType\CardsExpirationListSearchResult
     */
    public function setCardExpirationCountsList(\eBizCharge\ArrayType\ArrayOfCardExpirationCounts $cardExpirationCountsList = null)
    {
        $this->CardExpirationCountsList = $cardExpirationCountsList;
        return $this;
    }
}
